package com.yaohun.questsystem;

import com.yaohun.questsystem.api.QuestAPI;
import com.yaohun.questsystem.data.PlayerData;
import com.yaohun.questsystem.data.QuestData;
import com.yaohun.questsystem.data.database.SqlManager;
import com.yaohun.questsystem.listener.JoinEvent;
import com.yaohun.questsystem.manage.DataManage;
import com.yaohun.questsystem.util.SqlUtil;
import com.yaohun.questsystem.util.TimeType;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

import java.util.List;

public class Main extends JavaPlugin {

    public static Main plugin;
    public static DataManage dataManage;
    public static SqlManager sqlManager;
    public static SqlUtil sqlUtil;

    @Override
    public void onEnable() {
        plugin = this;
        DemonAPI.sendConsoleMessage("§f[§6!§f] §aQuestSystem (1.0) §f开始加载");
        LinkMySqlData();
        saveDefaultConfig();
        dataManage = new DataManage();
        for (Player player : Bukkit.getOnlinePlayers()){
            Main.dataManage.loadPlayerData(player);
        }
        getServer().getPluginManager().registerEvents(new JoinEvent(),this);
        DemonAPI.sendConsoleMessage("§f[§6!§f] §aQuestSystem §f加载完成,祝你使用愉快！");
        DemonAPI.sendConsoleMessage("§f[§6!§f] §b极光像素工作室出品");
    }

    public void LinkMySqlData(){
        String SQL_Host = "gz-cdb-r9koldtt.sql.tencentcdb.com";
        String SQL_Port = "29320";
        String SQL_Users = "root";
        String SQL_Password = "Pixel@123456";
        String SQL_Database = "quest";
        sqlManager = new SqlManager();
        sqlUtil = new SqlUtil(SQL_Host,SQL_Port,SQL_Database,SQL_Users,SQL_Password);
        sqlManager.createTable();
    }

    @Override
    public void onDisable() {
        for (Player player : Bukkit.getOnlinePlayers()){
            dataManage.savePlayerData(player);
        }
        DemonAPI.sendConsoleMessage("§f[§c!§f] §aQuestSystem §f卸载完成,欢迎下次使用！");
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String Command, String[] args) {
        if (Command.equalsIgnoreCase("questinfo") && sender instanceof Player player) {
            sender.sendMessage("§f[§e!§f]§7查询玩家: "+player.getName());
            sender.sendMessage("§f[§e!§f]§7任务数据:");
            PlayerData data = dataManage.getPlayerData(player);
            List<QuestData> everydayList = QuestAPI.getPlayerQuestList(player, TimeType.EVERYDAY);
            for (QuestData quest : everydayList){
                sender.sendMessage(" [每日] §b"+quest.getQuestKey()+" §f进度: §c"+data.getQuestAmount(quest)+"§f/§a"+quest.getNeedAmount());
            }
            List<QuestData> weeklyList = QuestAPI.getPlayerQuestList(player, TimeType.WEEKLY);
            for (QuestData quest : weeklyList){
                sender.sendMessage(" [每周] §b"+quest.getQuestKey()+" §f进度: §c"+data.getQuestAmount(quest)+"§f/§a"+quest.getNeedAmount());
            }
            List<QuestData> longTermList = QuestAPI.getPlayerQuestList(player, TimeType.LONGTERM);
            for (QuestData quest : longTermList){
                sender.sendMessage(" [长期] §b"+quest.getQuestKey()+" §f进度: §c"+data.getQuestAmount(quest)+"§f/§a"+quest.getNeedAmount());
            }
        }
        if (Command.equalsIgnoreCase("quest")) {
            Player player = (Player) sender;
            if(args.length == 1 && args[0].equalsIgnoreCase("save")) {
                if (dataManage.getPlayerData(player) != null) {
                    dataManage.savePlayerData(player);
                }
                DemonAPI.sendMessage(sender,"数据已保存至数据库.");
            }
            /*if(args.length == 2 && args[0].equalsIgnoreCase("js")) {
                String questKey = args[1];
                // 判断这个任务是否存在
                QuestData questData = dataManage.getQuestData(questKey);
                if(questData == null){
                    DemonAPI.sendMessage(sender,"任务: "+questKey+" 不存在");
                    return true;
                }
                PlayerData playerData = dataManage.getPlayerData(player);
                // 判断玩家是否已接受任务
                if(playerData.isAcceptQuest(questData)){
                    DemonAPI.sendMessage(sender,"任务: "+questKey+" 已接受");
                    return true;
                }
                // 判断玩家是否已完成任务
                if(playerData.isFinished(questData)){
                    DemonAPI.sendMessage(sender,"任务: "+questKey+" 已完成");
                    return true;
                }
                playerData.acceptQuest(questData);
                DemonAPI.sendMessage(sender,"任务: "+questKey+" 已接受");
            }
            if(args.length == 2 && args[0].equalsIgnoreCase("add")) {
                String questKey = args[1];
                // 判断这个任务是否存在
                QuestData questData = dataManage.getQuestData(questKey);
                if(questData == null){
                    DemonAPI.sendMessage(sender,"任务: "+questKey+" 不存在");
                    return true;
                }
                PlayerData playerData = dataManage.getPlayerData(player);
                // 判断玩家是否已接受任务
                if(!playerData.isAcceptQuest(questData)){
                    DemonAPI.sendMessage(sender,"任务: "+questKey+" 未接受");
                    return true;
                }
                playerData.addQuestAmount(questData);
                DemonAPI.sendMessage(sender,"任务: "+questKey+" 当前进度: "+playerData.getQuestAmount(questData)+"/"+questData.getNeedAmount()+"["+(playerData.getProgress(questData) * 100)+"%]");
            }
            if(args.length == 3 && args[0].equalsIgnoreCase("add")) {
                String questKey = args[1];
                // 判断这个任务是否存在
                QuestData questData = dataManage.getQuestData(questKey);
                if(questData == null){
                    DemonAPI.sendMessage(sender,"任务: "+questKey+" 不存在");
                    return true;
                }
                PlayerData playerData = dataManage.getPlayerData(player);
                // 判断玩家是否已接受任务
                if(!playerData.isAcceptQuest(questData)){
                    DemonAPI.sendMessage(sender,"任务: "+questKey+" 未接受");
                    return true;
                }
                int amount = Integer.parseInt(args[2]);
                playerData.addQuestAmount(questData,amount);
                DemonAPI.sendMessage(sender,"任务: "+questKey+" 当前进度: "+playerData.getQuestAmount(questData)+"/"+questData.getNeedAmount()+"["+(playerData.getProgress(questData) * 100)+"%]");
            }
            if(args.length == 2 && args[0].equalsIgnoreCase("tj")) {
                String questKey = args[1];
                // 判断这个任务是否存在
                QuestData questData = dataManage.getQuestData(questKey);
                if(questData == null){
                    DemonAPI.sendMessage(sender,"任务: "+questKey+" 不存在");
                    return true;
                }
                PlayerData playerData = dataManage.getPlayerData(player);
                // 判断玩家是否已接受任务
                if(!playerData.isAcceptQuest(questData)){
                    DemonAPI.sendMessage(sender,"任务: "+questKey+" 未接受");
                    return true;
                }
                // 判断玩家是否已完成任务
                if(playerData.isFinished(questData)){
                    DemonAPI.sendMessage(sender,"任务: "+questKey+" 已完成");
                    return true;
                }
                if (!playerData.canSubmitQuest(questData)) {
                    DemonAPI.sendMessage(sender,"任务: "+questKey+" 任务尚未完成");
                    return true;
                }
                playerData.submitQuest(questData);
                DemonAPI.sendMessage(sender,"任务: "+questKey+" 已提交");
            }*/
        }
        return true;
    }
}
