package com.yaohun.questsystem.data;

import com.yaohun.questsystem.util.TimeType;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;

import java.util.List;

public class QuestData {

    private String questKey; // 任务名
    private String name; // 任务名
    private TimeType timeType; // 任务时间
    private String type; // 任务类型
    private String target;
    private int needAmount;
    private List<String> finish;
    private List<String> description;

    public QuestData(String questKey,FileConfiguration yml){
        this.questKey = questKey;
        String cycle = yml.getString(questKey+".timeType","longTerm");
        if(cycle.equalsIgnoreCase("everyday")){
            timeType = TimeType.EVERYDAY;
        }else if(cycle.equalsIgnoreCase("weekly")){
            timeType = TimeType.WEEKLY;
        }else if(cycle.equalsIgnoreCase("longTerm")){
            timeType = TimeType.LONGTERM;
        }
        this.name = yml.getString(questKey+".name");
        this.type = yml.getString(questKey+".type");
        this.target = yml.getString(questKey+".content.name");
        this.needAmount = yml.getInt(questKey+".content.amount");
        this.finish = yml.getStringList(questKey+".finish");
        this.description = yml.getStringList(questKey+".description");
    }

    public String getQuestKey() {
        return questKey;
    }

    public TimeType getTimeType() {
        return timeType;
    }

    public String getName() {
        return name;
    }

    public String getType() {
        return type;
    }

    public String getTarget() {
        return target;
    }

    public int getNeedAmount() {
        return needAmount;
    }

    public List<String> getDescription() {
        return description;
    }

    public void sendFinishCommand(Player player){
        if(player == null){return;}
        DemonAPI.ConsoleOutCommandList(player,getFinish());
    }

    public List<String> getFinish() {
        return finish;
    }
}
